标签: 数据结构

[Baltic2004]Sequence 题解

[Baltic2004]Sequence 题解

题目地址:洛谷:【P4331】[BOI2004]Sequence 数字序列 – 洛谷、BZOJ:Problem 1367. — [Baltic2004]sequence

题目描述

1367 1 - [Baltic2004]Sequence 题解

输入输出格式

输入格式:
1367 2 - [Baltic2004]Sequence 题解

输出格式:
第一行输出最小的绝对值之和。
第二行输出序列 bi ,若有多种方案,只需输出其中一种。

输入输出样例

输入样例#1:

5
2 5 46 12 1

输出样例#1:

47
2 5 11 12 13

说明

【数据范围】
40%的数据 n≤5000
60%的数据 n≤300000
100%的数据 n≤1000000 , 0≤a_i≤2×10^9

题解

考虑当所求序列$z_i$是不降的情况应该如何解决。我们有两种情况:

  1. $t_1 \leq t_2 \leq \cdots \leq t_n$:$z_i=t_i$即可
  2. $t_1 \geq t_2 \geq \cdots \geq t_n$:取这些值的中位数作为所有的$z_i$值,这是由于取中位数的时候可以证明答案最小

因此,我们可以将$t$数列分为若干区间,每个区间的答案即其中位数,从而解决这个问题。
然而题目让我们求一个严格递增的序列,我们考虑将$t_i$处理成$t_i – i$,就可以用跟上面一致的方法解决这个问题,因为处理完毕后的数列不降等价于原数列单增。
实现上,我们对每个元素建一个可并堆,然后向左合并左边元素构成的可并堆(即左边的区间),直到这个区间的中位数不小于左边相邻区间的中位数。中位数可以利用大根堆维护,让堆的大小不大于$\left\lceil \frac{|S|}{2} \right\rceil$再取堆顶即可。
复杂度$O(n \log n)$。

代码

// Code by KSkun, 2018/7
#include <cstdio>
#include <cctype>
#include <cstring>

#include <algorithm>

typedef long long LL;

inline char fgc() {
    static char buf[100000], *p1 = buf, *p2 = buf;
    return p1 == p2 && (p2 = (p1 = buf) + fread(buf, 1, 100000, stdin), p1 == p2)
        ? EOF : *p1++;
}

inline LL readint() {
    register LL res = 0, neg = 1; register char c = fgc();
    for(; !isdigit(c); c = fgc()) if(c == '-') neg = -1;
    for(; isdigit(c); c = fgc()) res = (res << 1) + (res << 3) + c - '0';
    return res * neg;
}

const int MAXN = 1000005;

int n, a[MAXN];

struct Node {
    int ch[2], fa, val, dis, siz;
} tr[MAXN];
int rt[MAXN], l[MAXN], r[MAXN], htot;

inline int merge(int x, int y) {
    if(!x || !y) return x + y;
    if(tr[x].val < tr[y].val) std::swap(x, y);
    tr[x].ch[1] = merge(tr[x].ch[1], y);
    tr[x].siz = tr[tr[x].ch[0]].siz + tr[tr[x].ch[1]].siz + 1;
    tr[tr[x].ch[1]].fa = x;
    if(tr[tr[x].ch[0]].dis < tr[tr[x].ch[1]].dis) std::swap(tr[x].ch[0], tr[x].ch[1]);
    tr[x].dis = tr[tr[x].ch[1]].dis + 1;
    return x;
}

int main() {
    n = readint();
    for(int i = 1; i <= n; i++) {
        a[i] = readint() - i;
    }
    for(int i = 1; i <= n; i++) {
        htot++; rt[htot] = i;
        l[htot] = r[htot] = i;
        tr[i].val = a[i]; tr[i].siz = 1;
        while(htot > 1 && tr[rt[htot]].val < tr[rt[htot - 1]].val) {
            htot--;
            rt[htot] = merge(rt[htot], rt[htot + 1]);
            r[htot] = r[htot + 1];
            while(tr[rt[htot]].siz * 2 > r[htot] - l[htot] + 2) {
                rt[htot] = merge(tr[rt[htot]].ch[0], tr[rt[htot]].ch[1]);
            }
        }
    }
    LL ans = 0;
    for(int i = 1; i <= htot; i++) {
        int w = tr[rt[i]].val;
        for(int j = l[i]; j <= r[i]; j++) {
            ans += abs(w - a[j]);
        }
    }
    printf("%lld\n", ans);
    for(int i = 1; i <= htot; i++) {
        int w = tr[rt[i]].val;
        for(int j = l[i]; j <= r[i]; j++) {
            printf("%d ", w + j);
        }
    }
    return 0;
}
[NOI2004]郁闷的出纳员 题解

[NOI2004]郁闷的出纳员 题解

题目地址:洛谷:【P1486】[NOI2004]郁闷的出纳员 – 洛谷、BZOJ:Problem 1503. — [NOI2004]郁闷的出纳员

题目描述

OIER公司是一家大型专业化软件公司,有着数以万计的员工。作为一名出纳员,我的任务之一便是统计每位员工的工资。这本来是一份不错的工作,但是令人郁闷的是,我们的老板反复无常,经常调整员工的工资。如果他心情好,就可能把每位员工的工资加上一个相同的量。反之,如果心情不好,就可能把他们的工资扣除一个相同的量。我真不知道除了调工资他还做什么其它事情。
工资的频繁调整很让员工反感,尤其是集体扣除工资的时候,一旦某位员工发现自己的工资已经低于了合同规定的工资下界,他就会立刻气愤地离开公司,并且再也不会回来了。每位员工的工资下界都是统一规定的。每当一个人离开公司,我就要从电脑中把他的工资档案删去,同样,每当公司招聘了一位新员工,我就得为他新建一个工资档案。
老板经常到我这边来询问工资情况,他并不问具体某位员工的工资情况,而是问现在工资第k多的员工拿多少工资。每当这时,我就不得不对数万个员工进行一次漫长的排序,然后告诉他答案。
好了,现在你已经对我的工作了解不少了。正如你猜的那样,我想请你编一个工资统计程序。怎么样,不是很困难吧?
如果某个员工的初始工资低于最低工资标准,那么将不计入最后的答案内

题意简述

维护一个集合,四种操作:

  1. 插入一个数
  2. 集合全体加一个数
  3. 集合全体减一个数
  4. 查第$k$大数(即从大到小第$k$个)

如果全体减数以后某些元素小于了阈值,从集合中删去它们,并记录下整个过程中总共删了多少数,在最后输出。

输入输出格式

输入格式:
第一行有两个非负整数n和min。n表示下面有多少条命令,min表示工资下界。
接下来的n行,每行表示一条命令。命令可以是以下四种之一:
名称 格式 作用
I命令 I_k 新建一个工资档案,初始工资为k。如果某员工的初始工资低于工资下界,他将立刻离开公司。
A命令 A_k 把每位员工的工资加上k
S命令 S_k 把每位员工的工资扣除k
F命令 F_k 查询第k多的工资
_(下划线)表示一个空格,I命令、A命令、S命令中的k是一个非负整数,F命令中的k是一个正整数。
在初始时,可以认为公司里一个员工也没有。

输出格式:
输出文件的行数为F命令的条数加一。
对于每条F命令,你的程序要输出一行,仅包含一个整数,为当前工资第k多的员工所拿的工资数,如果k大于目前员工的数目,则输出-1。
输出文件的最后一行包含一个整数,为离开公司的员工的总数。

输入输出样例

输入样例#1:

9 10
I 60
I 70
S 50
F 2
I 30
S 15
A 5
F 1
F 2

输出样例#1:

10
20
-1
2

说明

I命令的条数不超过100000
A命令和S命令的总条数不超过100
F命令的条数不超过100000
每次工资调整的调整量不超过1000
新员工的工资不超过100000

题解

显然可以用平衡树来维护,这里写的是Splay。
插入很常规。考虑在外面维护一个标记来记录集合内的总体变化值$delta$,然后在插入删除的时候用它来处理。减数删除的时候可以先向集合中插入一个$k-delta-1$,把这个节点转到根,然后把它和左子树都删掉,往删点数里加上这一堆数的个数-1即可。
复杂度$O(n \log n)$。

代码

// Code by KSkun, 2018/7
#include <cstdio>
#include <cctype>
#include <cstring>

#include <algorithm>

typedef long long LL;

inline char fgc() {
    static char buf[100000], *p1 = buf, *p2 = buf;
    return p1 == p2 && (p2 = (p1 = buf) + fread(buf, 1, 100000, stdin), p1 == p2)
        ? EOF : *p1++;
}

inline LL readint() {
    register LL res = 0, neg = 1; register char c = fgc();
    for(; !isdigit(c); c = fgc()) if(c == '-') neg = -1;
    for(; isdigit(c); c = fgc()) res = (res << 1) + (res << 3) + c - '0';
    return res * neg;
}

inline char readsingle() {
    char c;
    while(!isalpha(c = fgc())) {}
    return c;
}

const int MAXN = 500005;

struct Node {
    int ch[2], fa, siz, cnt, val;
} tr[MAXN];
int rt, tot, sta[MAXN], stop;

inline int newnode() {
    int p;
    if(stop) {
        p = sta[--stop];
    } else {
        p = ++tot;
    }
    memset(tr + p, 0, sizeof(Node));
    return p;
}

inline void delnode(int p) {
    sta[stop++] = p;
}

inline void update(int p) {
    tr[p].siz = tr[tr[p].ch[0]].siz + tr[tr[p].ch[1]].siz + tr[p].cnt;
}

inline bool isleft(int p) {
    return tr[tr[p].fa].ch[0] == p;
}

inline void rotate(int p) {
    bool t = !isleft(p); int fa = tr[p].fa, ffa = tr[fa].fa;
    tr[p].fa = ffa; if(ffa) tr[ffa].ch[!isleft(fa)] = p;
    tr[fa].ch[t] = tr[p].ch[!t]; tr[tr[fa].ch[t]].fa = fa;
    tr[p].ch[!t] = fa; tr[fa].fa = p;
    update(fa);
    if(!tr[p].fa) rt = p;
}

inline void splay(int p, int tar) {
    for(int fa = tr[p].fa; fa != tar; rotate(p), fa = tr[p].fa) {
        if(tr[fa].fa != tar) rotate(isleft(fa) == isleft(p) ? fa : p);
    }
    update(p);
}

inline int queryk(int k) {
    int p = rt;
    for(;;) {
        if(tr[tr[p].ch[1]].siz >= k) {
            p = tr[p].ch[1];
        } else if(tr[tr[p].ch[1]].siz + tr[p].cnt >= k) {
            return tr[p].val;
        } else {
            k -= tr[tr[p].ch[1]].siz + tr[p].cnt;
            p = tr[p].ch[0];
        }
    }
}

inline int insert(int v) {
    if(!rt) {
        rt = ++tot;
        tr[rt].val = v;
        tr[rt].siz = 1;
        tr[rt].cnt = 1;
        return rt;
    }
    int p = rt, fa = 0;
    while(p) {
        fa = p;
        if(tr[p].val > v) p = tr[p].ch[0];
        else if(tr[p].val == v) {
            tr[p].cnt++; splay(p, 0); return p;
        } else p = tr[p].ch[1];
    }
    p = ++tot;
    tr[p].val = v;
    tr[p].siz = 1;
    tr[p].cnt = 1;
    tr[p].fa = fa;
    if(tr[fa].val > v) tr[fa].ch[0] = p;
    else tr[fa].ch[1] = p;
    splay(p, 0);
    return p;
}

int n, mn, del, ltot;

int main() {
    n = readint(); mn = readint();
    while(n--) {
        char op = readsingle();
        int k = readint();
        if(op == 'I') {
            if(k >= mn) insert(k - del);
        } else if(op == 'A') {
            del += k;
        } else if(op == 'S') {
            del -= k;
            int p = insert(mn - 1 - del);
            tr[tr[p].ch[1]].fa = 0; rt = tr[p].ch[1];
            ltot += tr[tr[p].ch[0]].siz + tr[p].cnt - 1;
        } else {
            if(k > tr[rt].siz) puts("-1");
            else printf("%d\n", queryk(k) + del);
        }
    }
    printf("%d", ltot);
    return 0;
}
Codeforces Round #495 (Div. 2) 赛后总结

Codeforces Round #495 (Div. 2) 赛后总结

比赛地址:Dashboard – Codeforces Round #495 (Div. 2) – Codeforces
官方题解:Codeforces Round #495 (Div. 2) — Editorial – Codeforces

1004A Sonya and Hotels

题意简述

一维空间坐标轴上有$n$个整点位置修建了酒店,现在想在一个未建酒店的整点位置修一个新酒店,要求新酒店离最近的酒店的距离等于$d$,求新酒店可以选择的坐标数量。
数据范围:$1 \leq 100, 1 \leq d \leq 10^9$

思路

枚举每两个酒店之间的距离,$距离=2d$的时候对答案有1的贡献,$>2d$的时候有2的贡献,首尾各有1的贡献,统计一下就好。
复杂度$O(n)$。

代码

// Code by KSkun, 2018/7
#include <cstdio>
#include <cctype>
#include <cstring>

#include <algorithm>

typedef long long LL;

inline char fgc() {
    static char buf[100000], *p1 = buf, *p2 = buf;
    return p1 == p2 && (p2 = (p1 = buf) + fread(buf, 1, 100000, stdin), p1 == p2)
        ? EOF : *p1++;
}

inline LL readint() {
    register LL res = 0, neg = 1; register char c = fgc();
    for(; !isdigit(c); c = fgc()) if(c == '-') neg = -1;
    for(; isdigit(c); c = fgc()) res = (res << 1) + (res << 3) + c - '0';
    return res * neg;
}

const int MAXN = 105;

int n, d, x[MAXN];

int main() {
    n = readint(); d = readint();
    for(int i = 1; i <= n; i++) {
        x[i] = readint();
    }
    int ans = 2;
    for(int i = 2; i <= n; i++) {
        if(x[i] - x[i - 1] == 2 * d) ans++;
        if(x[i] - x[i - 1] > 2 * d) ans += 2;
    }
    printf("%d", ans);
    return 0;
}

1004B Sonya and Exhibition

题意简述

要放$n$盆花成一排,每个位置有两种选择,有$m$个人参观这些花,他们会参观一个连续区间的花,参观的美丽度定义为区间两种花的个数的乘积,求安排方案使得美丽度之和最大。
数据范围:$1 \leq n, m \leq 10^3$

思路

$$ n^2 > (n+1)(n-1) > (n+2)(n-2) > \cdots $$
因此我们可以直接输出一个类似0101010101010101这样的序列就好了。
复杂度$O(n)$。

代码

// Code by KSkun, 2018/7
#include <cstdio>
#include <cctype>
#include <cstring>

#include <algorithm>

typedef long long LL;

inline char fgc() {
    static char buf[100000], *p1 = buf, *p2 = buf;
    return p1 == p2 && (p2 = (p1 = buf) + fread(buf, 1, 100000, stdin), p1 == p2)
        ? EOF : *p1++;
}

inline LL readint() {
    register LL res = 0, neg = 1; register char c = fgc();
    for(; !isdigit(c); c = fgc()) if(c == '-') neg = -1;
    for(; isdigit(c); c = fgc()) res = (res << 1) + (res << 3) + c - '0';
    return res * neg;
}

const int MAXN = 1005;

int n, m, l[MAXN], r[MAXN];

int main() {
    n = readint(); m = readint();
    for(int i = 1; i <= m; i++) {
        l[i] = readint(); r[i] = readint();
    }
    LL sum1 = 0, sum2 = 0;
    for(int i = 1; i <= m; i++) {
        int cnt1[2] = {0, 0}, cnt2[2] = {0, 0};
        for(int j = l[i]; j <= r[i]; j++) {
            cnt1[j & 1]++;
            cnt2[(j & 1) ^ 1]++;
        }
        sum1 += 1ll * cnt1[0] * cnt1[1];
        sum2 += 1ll * cnt2[0] * cnt2[1];
    }
    if(sum1 > sum2) {
        fprintf(stderr, "%lld\n", sum1);
        for(int i = 1; i <= n; i++) {
            putchar('0' + (i & 1));
        }
    } else {
        fprintf(stderr, "%lld\n", sum2);
        for(int i = 1; i <= n; i++) {
            putchar('0' + ((i & 1) ^ 1));
        }
    }
    return 0;
}

1004C Sonya and Robots

题意简述

有一个长为$n$的序列,两个机器人从序列的两段开始相向而行,遇到第一个与机器人中存储的数字相同的数字时就在该位置停下,你可以给机器人写入不同的数字,求让它们不相遇的数字对数。
数据范围:$1 \leq n \leq 10^5$

思路

我们从左向右扫这个序列,对于一个之前没有出现过的数字,显然它会与后面的不重复数字产生贡献,那么答案就是这些贡献的和。我们只需要知道一个位置的后面是否还有与这个位置相同的数字,动态地维护后面的不重复数字种数以及前面出现过哪些数字就可以了。
复杂度$O(n)$。

代码

// Code by KSkun, 2018/7
#include <cstdio>
#include <cctype>
#include <cstring>

#include <algorithm>

typedef long long LL;

inline char fgc() {
    static char buf[100000], *p1 = buf, *p2 = buf;
    return p1 == p2 && (p2 = (p1 = buf) + fread(buf, 1, 100000, stdin), p1 == p2)
        ? EOF : *p1++;
}

inline LL readint() {
    register LL res = 0, neg = 1; register char c = fgc();
    for(; !isdigit(c); c = fgc()) if(c == '-') neg = -1;
    for(; isdigit(c); c = fgc()) res = (res << 1) + (res << 3) + c - '0';
    return res * neg;
}

const int MAXN = 100005;

int n, a[MAXN], nxt[MAXN], head[MAXN];
bool vis[MAXN];

int main() {
    n = readint();
    int cnt = 0;
    LL ans = 0;
    for(int i = 1; i <= n; i++) {
        a[i] = readint();
        if(!vis[a[i]]) {
            vis[a[i]] = true;
            head[a[i]] = i;
            cnt++;
        } else {
            nxt[head[a[i]]] = i;
            head[a[i]] = i;
        }
    }
    memset(vis, 0, sizeof(vis));
    for(int i = 1; i <= n; i++) {
        if(!nxt[i]) {
            cnt--;
        }
        if(!vis[a[i]]) ans += cnt;
        vis[a[i]] = true;
    }
    printf("%lld", ans);
    return 0;
}

1004D Sonya and Matrix

题意简述

有一个矩阵,矩阵中有1个权值为0的格子,而其他格子的权值为到0权格子的曼哈顿距离。现在给你一个长为$t$的序列,是一个包含某一个矩阵里面的所有权值的乱序可重排列。现在你要求出原来矩阵的大小$n \times m$以及0权的位置$(x, y)$。
数据范围:$1 \leq t \leq 10^6$

思路

首先,我们可以用序列统计每个数字出现的次数。在完整的图形中,我们会发现每个数字形成了菱形或者说正方形的形状,如下所示。

          5
        5 4 5
      5 4 3 4 5
    5 4 3 2 3 4 5
  5 4 3 2 1 2 3 4 5
5 4 3 2 1 0 1 2 3 4 5
  5 4 3 2 1 2 3 4 5
    5 4 3 2 3 4 5
      5 4 3 4 5
        5 4 5
          5

我们可以求出序列中的最大数字以及最大的在矩阵中完整地出现了它的菱形的数字,显然,最大数字应该在角上,由于图形的对称性,四个角是等价的,我们暂且让它在左上角$(1, 1)$。
当我们发现矩形的大小并无法让0与最大数共存的时候,显然情况不合法,这种情况的判断,我们可以使用对角线曼哈顿距离(即图形中的最长曼哈顿距离)来判断,即$n+m-2 < mx$时不合法。
另外的不合法情况就是当确定了$n, m, x, y$以后,我们可以计算出最大的整个菱形都包含进来的数字,这个数字是$\min \{ x-1, y-1, n-x, m-y \}$,再把不合法的情况扔掉就好。
剩下的合法情况已经很少了,我们直接暴力$O(t)$地验证就好。

代码

// Code by KSkun, 2018/7
#include <cstdio>
#include <cctype>
#include <cstring>
#include <cmath>

#include <algorithm>

typedef long long LL;

inline char fgc() {
    static char buf[100000], *p1 = buf, *p2 = buf;
    return p1 == p2 && (p2 = (p1 = buf) + fread(buf, 1, 100000, stdin), p1 == p2)
        ? EOF : *p1++;
}

inline LL readint() {
    register LL res = 0, neg = 1; register char c = fgc();
    for(; !isdigit(c); c = fgc()) if(c == '-') neg = -1;
    for(; isdigit(c); c = fgc()) res = (res << 1) + (res << 3) + c - '0';
    return res * neg;
}

const int MAXN = 1000005;

int t, mx, cnt[MAXN], cnt2[MAXN];

inline int border(int n, int m, int x, int y) {
    return std::min(std::min(x - 1, y - 1), std::min(n - x, m - y));
}

inline bool check(int n, int m, int x, int y) {
    memset(cnt2, 0, sizeof(cnt2));
    for(int i = 1; i <= n; i++) {
        for(int j = 1; j <= m; j++) {
            cnt2[abs(x - i) + abs(y - j)]++;
        }
    }
    for(int i = 1; i <= t; i++) {
        if(cnt2[i] != cnt[i]) return false;
    }
    return true;
}

int main() {
    t = readint();
    for(int i = 1; i <= t; i++) {
        int a = readint();
        cnt[a]++;
        mx = std::max(mx, a);
    }
    int lim = 0;
    for(int i = 1; i <= t; i++) {
        if(cnt[i] != i * 4) {
            lim = i - 1; break;
        }
    }
    for(int n = 1; n * n <= t; n++) {
        if(t % n) continue;
        int m = t / n;
        if(n + m - 2 < mx) continue;
        for(int j = 1; j <= n; j++) {
            int k = mx - j + 2;
            if(k > m || k < 1) continue;
            if(border(n, m, j, k) != lim) continue;
            if(check(n, m, j, k)) {
                printf("%d %d\n%d %d", n, m, j, k);
                return 0;
            }
        }
    }
    puts("-1");
    return 0;
}

1004E Sonya and Ice Cream

题意简述

给你一棵$n$个点的树,要求从中选出一条不超过$k$个点的路径,使得树的其他点到这条路径的最短距离最大值最小。
数据范围:$1 \leq k \leq n \leq 10^5$

思路

首先,我们可以证明,这条路径在包含树的中心点的时候比较优,中心点定义为到这个点最远的点距离最小的点,显然,这个点应该在直径的中心位置,可以$O(n)$求出来。
答案具有二分性质,所以我们二分答案,接着考虑如何验证。我们可以从中心点开始DFS,每次扩展出去一个点,如果发现一个点的子树中最远的点到它的距离大于答案,则这个点一定要被加入路径。如果一个点有多个儿子一定要被加入路径(中心点特殊考虑,它允许有2个儿子必须被加入路径)则不合法。如果必须被加入路径的点数多于$k$则不合法,判断一下就好。
复杂度$O(n \log n)$。

代码

// Code by KSkun, 2018/7
#include <cstdio>
#include <cctype>
#include <cstring>

#include <algorithm>
#include <vector>

typedef long long LL;

inline char fgc() {
    static char buf[100000], *p1 = buf, *p2 = buf;
    return p1 == p2 && (p2 = (p1 = buf) + fread(buf, 1, 100000, stdin), p1 == p2)
        ? EOF : *p1++;
}

inline LL readint() {
    register LL res = 0, neg = 1; register char c = fgc();
    for(; !isdigit(c); c = fgc()) if(c == '-') neg = -1;
    for(; isdigit(c); c = fgc()) res = (res << 1) + (res << 3) + c - '0';
    return res * neg;
}

const int MAXN = 100005;

struct Edge {
    int to, w;
};
std::vector<Edge> gra[MAXN];

int n, k, du, dv, ct, fa[MAXN], dis[MAXN];

inline void dfs_dis(int u) {
    for(auto e : gra[u]) {
        if(e.to == fa[u]) continue;
        dis[e.to] = dis[u] + e.w;
        fa[e.to] = u;
        dfs_dis(e.to);
    }
}

inline void diameter() {
    dfs_dis(1);
    for(int i = 1; i <= n; i++) {
        if(dis[i] > dis[du]) du = i;
    }
    dis[du] = 0;
    memset(fa, 0, sizeof(fa));
    dfs_dis(du);
    for(int i = 1; i <= n; i++) {
        if(dis[i] > dis[dv]) dv = i;
    }
}

inline void center() {
    for(int i = dv; i; i = fa[i]) {
        if(std::max(dis[ct], dis[dv] - dis[ct]) > std::max(dis[i], dis[dv] - dis[i])) {
            ct = i;
        }
    }
}

int cnt;
bool success;

inline int dfs_check(int u, int fa, int lim) {
    int res = 0, big = 0;
    for(auto e : gra[u]) {
        if(e.to == fa) continue;
        int dis = dfs_check(e.to, u, lim);
        if(dis != -1 && dis + e.w > lim) {
            cnt++; big++;
        }
        if(dis == -1) big++;
        else res = std::max(res, dis + e.w);
    }
    if((u == ct && big > 2) || (u != ct && big > 1)) {
        success = false;
    }
    if(big || u == ct) {
        cnt++; return -1;
    }
    return res;
}

inline bool check(int mid) {
    cnt = 0; success = true;
    dfs_check(ct, 0, mid);
    return success && cnt <= k;
}

int main() {
    n = readint(); k = readint();
    for(int i = 1, u, v, w; i < n; i++) {
        u = readint(); v = readint(); w = readint();
        gra[u].push_back(Edge {v, w});
        gra[v].push_back(Edge {u, w});
    }
    diameter(); center();
    int l = -1, r = 1e9, mid;
    while(r - l > 1) {
        mid = (l + r) >> 1;
        if(check(mid)) r = mid; else l = mid;
    }
    printf("%d", r);
    return 0;
}

1004F Sonya and Bitwise OR

题意简述

维护一个长为$n$的序列,有$m$次操作,支持两种操作

  1. 单点修改
  2. 区间询问有多少连续子序列的异或和不小于$x$(对于所有的询问$x$都相同)

数据范围:$1 \leq n, m \leq 10^5$

思路

咕咕咕。

代码

咕咕咕。